%
% KECA Computes the principal components of the KECA method
%
% Input:  - K: kernel matrix. (Size: [MxM])
%
% Output: - V: KECA eigenvectors. (Size: [MxM])
%         - D: KECA eigenvalues. (Size: [MxM])
%
% Copyright (c) 2013  Emma Izquierdo-Verdiguier, Valero Laparra, 
%                     Robert Jenssen, Luis Gómez-Chova, and Gustavo Camps-Valls
%
%                     emma.izquierdo@uv.es, http://isp.uv.es
%

function [V,D]=keca(K)    


    D = -5;
    kk = 0;
    OPTIONS.disp = 0;
    while(min(diag(D))<0 || sum(abs(imag(diag(D))))>0)
        [V D] = eigs(K + kk*eye(size(K,1)),size(K,1));
        kk = kk + max([sum(abs(imag(diag(D)))) abs(min(diag(D)))]);
    end

    
    valores_keca = sum((V*(D.^0.5))).^2;
    
    [valores_keca ind_keca] = sort(valores_keca,'descend');
    
    V=V(:,ind_keca);
    D=D(ind_keca,ind_keca);
